#ifndef __GAME_H
#define __GAME_H
#include <d3dx9.h>
#include "Input.h"
#include "Renderer.h"
#include "Tunnel.h"

class Game
{
public:
	Game();
	~Game();

	bool Is_Running() const;
	float Get_Score() const;

	void Restart();

	void Update(float delta_t, Input *input);
	void Render(Renderer *renderer);

private:
	bool m_is_active;

	float m_hiscore;

	Single<Tunnel> m_tunnel;
	float m_tunnel_pos;

	D3DXVECTOR3 m_local_pos;
	D3DXVECTOR3 m_local_dir;

	float m_alpha_score;
	float m_alpha_menu;

	void Update_Menu(float delta_t, Input *input);
	void Update_Game(float delta_t, Input *input);
};

#endif
