#include "Mesh.h"

#include <stdio.h>

Mesh::Mesh()
	: m_vertices_size(0)
	, m_vertices_alloc(512)
	, m_vertices(new Vertex[512])
{
}

Mesh::~Mesh()
{
	if (m_vertices != 0)
		delete [] m_vertices;
}

int Mesh::Get_Size() const
{
	return m_vertices_size;
}

const Vertex *Mesh::Get_Vertices() const
{
	return m_vertices;
}

void Mesh::Clear()
{
	m_vertices_size = 0;
}

void Mesh::Add_Vertex(const Vertex &vtx, bool new_strip)
{
	// Start a new strip?
	if (new_strip && m_vertices_size > 0)
	{
		Vertex lst_vtx = m_vertices[m_vertices_size - 1];

		*Alloc_Vertex() = lst_vtx;
		*Alloc_Vertex() = vtx;
		// Fix the winding for the strip
		if ((m_vertices_size & 1) == 1)
			*Alloc_Vertex() = vtx;
	}

	// Add the vertex
	*Alloc_Vertex() = vtx;
}

Mesh::Mesh(const Mesh &oth)
	: m_vertices_size(0)
	, m_vertices_alloc(512)
	, m_vertices(new Vertex[512])
{
}

Vertex *Mesh::Alloc_Vertex()
{
	if (m_vertices_size >= m_vertices_alloc)
	{
		m_vertices_alloc = (m_vertices_alloc * 2) + 512;

		Vertex *new_lst = new Vertex[m_vertices_alloc];
		if (m_vertices_size > 0)
			memcpy(new_lst, m_vertices, m_vertices_size * sizeof(Vertex));

		delete [] m_vertices;
		m_vertices = new_lst;
	}

	return &m_vertices[m_vertices_size++];
}
